--能量收取
Lua_GodStatueEnergyWindow = class("Lua_GodStatueEnergyWindow", Lua_Window);
function Lua_GodStatueEnergyWindow:ctor()
    self:superCall("ctor");
    self.showBlackMask = true;
    self.isClickClose = true;
    self.windowName = "Lua_GodStatueEnergyWindow";
    self.skinName="GodStatueEnergyWindow_skin";
end

function Lua_GodStatueEnergyWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.dragList = Lua_DragList.new(self.content,624, 302, Lua_AxisDefine.Vertical);
    self.dragList:setListCell(Lua_GodStatueEnergyCell, 112, 148, 5);
    self.dragList:setCellSpacing(16, 6);
    self.dragList:setLocation(0, 27);

    self.collectBtn:addClickFuntion(self, self.onCollectBtnClick);
    self:showEnergyInfo();
end

function Lua_GodStatueEnergyWindow:showEnergyInfo()
    local tvo = Lua_ToolVo.new(Lua_ResourcesDefine.HERO_PROVE);
    self.icon:setAltas(tvo.iconAtlas,tvo.iconSprite);
    self.num.text = DataCenter.lifeTreeData.energy_num;
    self.dragList:setArrayData(DataCenter.lifeTreeData.statueEnergyArr);
end

--收取
function Lua_GodStatueEnergyWindow:onMaskClick(go)
    self:superCall("onMaskClick");
    Lua_ProxyManager.getProxy("Lua_LifeTreeProxy"):sGetStatueEnergy();
end

--收取
function Lua_GodStatueEnergyWindow:onBtnCloseClick(go)
    self:superCall("onMaskClick");
    Lua_ProxyManager.getProxy("Lua_LifeTreeProxy"):sGetStatueEnergy();
end

--收取
function Lua_GodStatueEnergyWindow:onCollectBtnClick()
    Lua_ProxyManager.getProxy("Lua_LifeTreeProxy"):sGetStatueEnergy();
    self:hide();
end

function Lua_GodStatueEnergyWindow:dispose()
    self:superCall("dispose");
end












-- 能量展示Item
Lua_GodStatueEnergyCell = class("Lua_GodStatueEnergyCell", Lua_ListCell);
function Lua_GodStatueEnergyCell:ctor(p)
    self:superCall("ctor", p, "GodStatueEnergyCell_skin");
end

function Lua_GodStatueEnergyCell:buildShowItem()
    self:superCall("buildShowItem");
    self.itemIcon = Lua_ItemIcon.new(self.content);
    self.itemIcon:setScale(0.9,0.9);
    self.itemIcon:setLocation(0, 16, 0);
    self.itemIcon:setCanClick(false);
end

function Lua_GodStatueEnergyCell:setData(data)
    local hvo = Lua_HeroVo.new(data.hero_id);
    hvo.star = data.star;
    hvo.level = 0;
    self.itemIcon:setData(hvo);

    local tvo = Lua_ToolVo.new(Lua_ResourcesDefine.HERO_PROVE);
    self.icon:setAltas(tvo.iconAtlas,tvo.iconSprite);
    self.num.text = data.energy_value;
end

function Lua_GodStatueEnergyCell:dispose()
    if self.itemIcon ~= nil then
        self.itemIcon:dispose();
        self.itemIcon = nil;
    end
    self:superCall("dispose");
end