--宝石
Lua_GodStatueStoneWindow = class("Lua_GodStatueStoneWindow", Lua_Window);
function Lua_GodStatueStoneWindow:ctor()
    self:superCall("ctor");
    self.showBlackMask = true;
    self.isClickClose = true;
    self.windowName = "Lua_GodStatueStoneWindow";
    self.skinName="GodStatueStoneWindow_skin";
end

function Lua_GodStatueStoneWindow:buildShowItem()
    self:superCall("buildShowItem");
    self.bg1:setEnable(false);
    self.itemIcon = Lua_ItemIcon.new(self.content);
    self.itemIcon:setScale(0.9,0.9);
    self.itemIcon:setLocation(0, -29, 0);
    self.itemIcon:setCanClick(true);

    self:addLuaEvent("GOD_STATUE_INFO", self, self.updateStatueStoneInfo);

    self.use_btn:addMousDownFuntion(self, self.onMouseDownHandle);
    self.use_btn:addMouseUpFuntion(self, self.onMouseUpHandle);

    self:updateStatueStoneInfo();
end

function Lua_GodStatueStoneWindow:updateStatueStoneInfo()
	self.have_num = DataCenter.packData:getItemCountById(Lua_PackDefine.STAR_STONE);
	local tvo = Lua_ToolVo.new(Lua_PackDefine.STAR_STONE);
    self.itemIcon:setData(tvo);
    self.itemIcon:showText(4,self.have_num.."/1");
    self.num_limit.text = ":  "..DataCenter.lifeTreeData.stone_num.."/"..DataCenter.lifeTreeUtil.inset_limit;
    self:updateProp()
end

-- 更新属性
function Lua_GodStatueStoneWindow:updateProp()
    local arr = DataCenter.lifeTreeUtil:getStatuePropInfo();
    if self.attributeArr == nil then
        self.attributeArr = Array();
    end
    local len = self.attributeArr:getSize();
    for i = 1, len do
        self.attributeArr[i]:setEnable(false);
    end
    for i = 1, arr:getSize() do
        local item = nil;
        if self.attributeArr[i] ~= nil then
            item = self.attributeArr[i];
        else
            item = Lua_StonePorpItem.new(self.content);
            self.attributeArr:add(item);
        end
        item:setData(arr[i]);
        item:setEnable(true);

        local x = 0;
        if i%2 == 0 then
            x = 30;
            i =i/2;
        else
            x = -287;
            i =(i+1)/2;
        end
        item:setLocation(x, 141 - (i-1)*48, 0);
    end

    self.bg1:setEnable(arr:getSize() > 2)
end

function Lua_GodStatueStoneWindow:onMouseDownHandle(go)
    self:onPress(go, true);
end

function Lua_GodStatueStoneWindow:onMouseUpHandle(go)
    self:onPress(go, false);
end

function Lua_GodStatueStoneWindow:onPress(go, state)
    if state == true then
        self.startClickTime = getTime(); -- 记录开始点击时间
        if self.isMouseDown == nil or self.isMouseDown == false then
            self.isMouseDown = true;
            Lua_CommonUtil.addTimer("onGodLongPressClick", 0.3, self, self.onLongPressClick);
        end
    else
        if self.startClickTime == nil then
            self.startClickTime = getTime();
        end
        if getTime() - self.startClickTime < 0.3 then -- 点击
            self:onUseBtnClick(false);
        end
        self:removeControlTime();
    end
end

--长按
function Lua_GodStatueStoneWindow:onLongPressClick()
    if  getTime() - self.startClickTime >= 0.3 then -- 长按
        self:onUseBtnClick(true);
        return;
    end
end

function Lua_GodStatueStoneWindow:removeControlTime(go) -- 移出计时器
    if self.isMouseDown == true then
        self.isMouseDown = false;
        self.startClickTime = nil;
        self.isShowTips = nil;
        Lua_CommonUtil.removeTimer(self,self.onLongPressClick);
    end
end

--镶嵌
function Lua_GodStatueStoneWindow:onUseBtnClick(bool)
    if self.isShowTips == true then--展示一次tips
        return;
    end

    if DataCenter.lifeTreeData.isStonelimit then--镶嵌已达上限
        if bool then
            self.isShowTips = true;
        end
        OperateAlert.showLangValue(126954);
        return
    end

    if self.have_num < 1 then
        if bool then
            self.isShowTips = true;
        end
        DataCenter.packUtil:openPathWindow(Lua_PackDefine.STAR_STONE);
        return
    end

    Lua_ProxyManager.getProxy("Lua_LifeTreeProxy"):sStoneInlay();
end

function Lua_GodStatueStoneWindow:dispose()
	if self.attributeArr ~= nil then
        self.attributeArr:dispose();
        self.attributeArr:clear();
    end
    self:removeControlTime();
    self:superCall("dispose");
end






























--宝石属性展示
Lua_StonePorpItem = class("Lua_StonePorpItem", Lua_DisplayObject);
function Lua_StonePorpItem:ctor(p)
    self:superCall("ctor", p,"StonePorpItem_skin");
end

function Lua_StonePorpItem:buildShowItem()
    self:superCall("buildShowItem");
end

function Lua_StonePorpItem:setData(data)
    local str = "";
    if data.nextValue > 0 then
        str = "<color=#459252>(+"..data.nextValue..")</color>";
    end
    local show_name = LanUtil.formateStr(126959, tostring(data.show_name));
    self.des.text = show_name..data.value..str;
end

function Lua_StonePorpItem:dispose()
    self:superCall("dispose");
end