--同调器
checkRequire("Lua_GodTreeGridCell");
checkRequire("Lua_GodTreeModelItem");
Lua_GodTreePanel = class("Lua_GodTreePanel", Lua_DisplayObject);
function Lua_GodTreePanel:ctor(p)
    self:superCall("ctor", p,"LifeTreePanel_skin");
end

function Lua_GodTreePanel:buildShowItem()
    self:superCall("buildShowItem");
    
    self.des:setLangValue(126933);
    self.upgradeBtn:setEnable(false);
    
    self.bg:SetDimensions(756, 453 + self.adaptHeight/2);
    self.bg1:SetDimensions(663, 331 + self.adaptHeight/2);
    -- LuaUtil.setObjPos(self.show_obj, 0, -self.adaptHeight, 0);

    self.dragList = Lua_DragList.new(self.show_obj, 640, 308 + self.adaptHeight/2, Lua_AxisDefine.Vertical);
    self.dragList:setListCell(Lua_GodTreeGridCell, 112, 112, 5);
    self.dragList:setRectPivot(1);
    self.dragList:setCellSpacing(20, 14);
    self.dragList:setLocation(0, -270);
    self.dragList.tweenId = 2003;

    self.help:addClickFuntion(self, self.onHelpBtnClick);
    self.unlockBtn:addClickFuntion(self, self.onUnlockBtnClick);--解锁
    self.upgradeBtn:addClickFuntion(self, self.onupgradeBtnBtnClick);--升级突破

    self:addLuaEvent("LIFE_TREE_INFO", self, self.updateLifeTreeInfo);
    self:addLuaEvent("LIFE_TREE_GRID_INFO", self, self.updateGridInfo);
    self:addLuaEvent("ENFORCE_UPDATA_HERO_PANEL", self, self.updateGridInfo);
    self:addLuaEvent("UPDATE_GOD_TAB_REDDOT", self, self.showRedDot);--红点更新


    Lua_ProxyManager.getProxy("Lua_LifeTreeProxy"):slifeTreeInfo();
end

--更新 生命同调器
function Lua_GodTreePanel:updateLifeTreeInfo()
    self.upgradeBtn:setEnable(DataCenter.lifeTreeData.break_state >=1)
	if DataCenter.lifeTreeData.break_state == 2 then--已突破
	    local isMaxLevel = DataCenter.lifeTreeUtil:isMaxLevel(DataCenter.lifeTreeData.cur_level);
	    if isMaxLevel == true then--最大等级
            self.showObj:SetActive(true);
	    	self.show_tips:setLangValue(126925);
	    	self:showupgradeBtnCost(nil);
	    else
            self.showObj:SetActive(false);
            local cost_list = DataCenter.lifeTreeUtil:lifeTreeCost(DataCenter.lifeTreeData.cur_level);
            self:showupgradeBtnCost(cost_list);
	    end
        self.upgradeBtn:setLangValue(126923);
        self:showMondelLevel(false);
        self:showMondel(false);
	else
        self:showMondelLevel(true);
        self:showMondel(true);
        if DataCenter.lifeTreeData.break_state == 1 then
            self.upgradeBtn:setLangValue(126922);
        end
	end
    
	if DataCenter.lifeTreeData.isActivateLifeTree == true then
        local str;
		if DataCenter.lifeTreeData.break_state == 2 then
			str = "Lv."..Lua_ColorDefine.getColorStr("ffe68e",DataCenter.lifeTreeData.cur_level).."/"..DataCenter.lifeTreeData.level_limit;
		else
            str = "Lv."..DataCenter.lifeTreeData.cur_level;
		end
        self.level.text = str;
        self.level:setEnable(true);
        self.cond_des:setEnable(false);
	else
        self.level:setEnable(false);
		self.cond_des:setEnable(true);
        self.cond_des:setLangValue(126902);
	end
    
    self:showRedDot();
end

-- 更新tween状态
function Lua_GodTreePanel:updateTween()
    self.dragList.showTween = true;
    self:updateGridInfo(true);
end

--升级突破红点
function Lua_GodTreePanel:showRedDot()
    local bool = DataCenter.lifeTreeData.breakRedDot;
    if bool == false then
        bool = DataCenter.lifeTreeData.upgradeRedDot;
    end
    if bool == true then
        if self.redDotIcon == nil then
            self.redDotIcon = Lua_RedPointIcon.new(self.show_obj);
            self.redDotIcon:setLocation(85, -125, 0);
            self.redDotIcon:createRedPointImg(nil);
        end
        self.redDotIcon:updateRedPointShow(true);
    else
        if self.redDotIcon ~= nil then
            self.redDotIcon:updateRedPointShow(false);
        end
    end
end

-- 更新格子数据
function Lua_GodTreePanel:updateGridInfo(bUpdate)
    if bUpdate == nil and self.bFrist == nil then
        self.bFrist = true;
        self.dragList.showTween = true;
    end
    local gridArr = DataCenter.lifeTreeData.guardGridInfo;
    self.dragList:setArrayData(gridArr);

    local color_str1 = Lua_ColorDefine.getColorStr("189a0b",DataCenter.lifeTreeData.curGridNum);
    local color_str2 = Lua_ColorDefine.getColorStr("595959","/"..gridArr:getSize());
    self.grid_num.text = color_str1..color_str2;
end

function Lua_GodTreePanel:showMondelLevel(bool)
    if bool then--等级
        local arr = DataCenter.lifeTreeData.showHeroInfo;--晶碑数据
        local pos = {{-280, -3}, {293, -3}, {-190, -60}, {204, -60}, {-71, -84},{71, -84}};--等级
        local eff_pos = {{2.84, 0.36, 4.93}, {-3.04, 0.31, 4.93}, {1.94, 0.23, 13.39}, {-2.07, 0.38, 16.77}, {0.72, 0.1, 16.44}, {-0.69, 0.1, 15.78}}
        local scale = {2,2,2,2,2,2};
        if self.mondlLevelInfo == nil then
            self.mondlLevelInfo = Array();
        end

        local siftItem;
        local len = DataCenter.lifeTreeUtil.enter_amount;
        for i=1,len do
            siftItem = self.mondlLevelInfo[i];
            if siftItem == nil then
               siftItem = Lua_GodTreeModelItem.new(self.content);
               self.mondlLevelInfo:add(siftItem);
            end
            siftItem:setLocation(pos[i][1], pos[i][2]);
            siftItem:setData(arr[i]);
            siftItem:showEffect(eff_pos[i][1], eff_pos[i][2], eff_pos[i][3], scale[i]);
        end
    else
        if self.mondlLevelInfo ~= nil then
            self.mondlLevelInfo:dispose();
            self.mondlLevelInfo:clear();
            self.mondlLevelInfo = nil;
        end
    end
end

-- 场景展示
function Lua_GodTreePanel:showTreeScene(scenePanel)
    self.modelScenePanel = scenePanel;
    local  bool = DataCenter.lifeTreeData.break_state ~= 2;
    self:showMondelLevel(bool);
    self.modelScenePanel:setModelEnable(bool);
end

function Lua_GodTreePanel:setModelEnable(bool)
    if self.modelScenePanel ~= nil then
        self:showMondelLevel(bool);
        self.modelScenePanel:setModelEnable(bool);
    end
end

-- 模型展示
function Lua_GodTreePanel:showMondel(bMondel)
    if self.modelScenePanel ~= nil and self.bMondel ~= bMondel then--场景模型
        self.bMondel = bMondel;
        if bMondel then
            local pos = {{2.84, 0.36, 4.93}, {-3.04, 0.31, 4.93}, {1.94, 0.23, 13.39}, {-2.07, 0.38, 16.77}, {0.72, 0.1, 16.44}, {-0.69, 0.1, 15.78}};
            local hvo;
            local arr = DataCenter.lifeTreeData.showHeroInfo;--晶碑数据
            for i=1,arr:getSize() do
                hvo = DataCenter.heroData:getItemByUniqueId(arr[i]);
                self.modelScenePanel:addSingleModel(i, hvo.uiModelUrl, hvo.uiModelAvatarName, hvo.poseActEffs, hvo.uiModelDir, 1, pos[i])
            end
        else
            self:setModelEnable(false);
        end
    end
end

-- 升级材料展示
function Lua_GodTreePanel:showupgradeBtnCost(list)
    if list ~= nil then
        if self.costInfo == nil then
            self.costInfo = Array();
        end
        local width = 229;
        local len = self.costInfo:getSize();
        for i = 1, len do
            self.costInfo[i]:setEnable(false);
        end
        for i = 1, #list do
            local item = nil;
            if self.costInfo[i] ~= nil then
                item = self.costInfo[i];
            else
                item = Lua_LifeTreeCostItem.new(self.show_obj);
                self.costInfo:add(item);
            end
            item:setData(list[i]);
            item:setLocation(-1 * width * #list / 2 + width * (i-1) + width / 2, -48, 0);
            item:setEnable(true);
        end
    else
        self.cost_list = nil;
        if self.costInfo ~= nil then
            local len = self.costInfo:getSize();
            for i = 1, len do
                self.costInfo[i]:setEnable(false);
            end
        end
    end
end

--同调器升级
function Lua_GodTreePanel:onupgradeBtnBtnClick()
    if DataCenter.lifeTreeData.break_state == 1 then --突破
        local tipData = {
            h = 443, titleAtlas = "life_tree_altas", titleSprite = "ui_tdq_title_01", pivot = Lua_WindowUtil.getPivot(0),
            font_size = 26, alignmentValue = 0, des = LanUtil.getValue(126901), posX = -281, posY = 60,
            btnType = 1, owner = self, sureFun = self.sendBreak
        };
        Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
        return 
    end

    local isMaxLevel = DataCenter.lifeTreeUtil:isMaxLevel(DataCenter.lifeTreeData.cur_level);
    if isMaxLevel == true then--同调器满级
        OperateAlert.showLangValue(126924);
    else
        if DataCenter.lifeTreeData.isLevelLimit == true then--同调器当前等级升满
            OperateAlert.showLangValue(126904);
        else
            local id = nil;
            local cost_list = DataCenter.lifeTreeUtil:lifeTreeCost(DataCenter.lifeTreeData.cur_level);
            for i=1, #cost_list do
                local need_num = cost_list[i][2];
                local bagNum = DataCenter.packData:getItemCountById(cost_list[i][1]);
                if bagNum < need_num then
                    id = cost_list[i][1];
                    break;
                end
            end
            if id == nil then
                Lua_ProxyManager.getProxy("Lua_LifeTreeProxy"):sUpgrade();
                OperateAlert.showLangValue(126930);
            else
                DataCenter.packUtil:openPathWindow(id);
            end
        end
    end
end

--突破
function Lua_GodTreePanel:sendBreak()
    Lua_ProxyManager.getProxy("Lua_LifeTreeProxy"):sBreak();
end

--解锁
function Lua_GodTreePanel:onUnlockBtnClick()
    if DataCenter.lifeTreeData.isUnlockMaxNum then --已经解锁全部
        OperateAlert.showLangValue(126927);
    else
        local index = DataCenter.lifeTreeData.curGridNum+1;
        local data = DataCenter.lifeTreeData.guardGridInfo[index];
        Lua_WindowUtil.openWin("Lua_GuardUnlockTipsWindow", Lua_WinParam.ACTION_OPEN, data);
    end
end

function Lua_GodTreePanel:onHelpBtnClick() 
    local tipsData = { des = LanUtil.getValue(126921), posX = 173, posY = -273 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_GodTreePanel:onScreenResize(adaptHeight)
    if self.adaptHeight == adaptHeight then
        return
    end
    self:superCall("onScreenResize", adaptHeight);
    
    self.bg:SetDimensions(756, 453 + adaptHeight/2);
    self.bg1:SetDimensions(663, 331 + adaptHeight/2);
    self.dragList:setContentRect(640, 308 + adaptHeight/2);
    self.dragList:moveToIndex(1);
end

function Lua_GodTreePanel:dispose()
    if self.mondlLevelInfo ~= nil then
        self.mondlLevelInfo:dispose();
        self.mondlLevelInfo:clear();
        self.mondlLevelInfo = nil;
    end
    if self.costInfo ~= nil then
        self.costInfo:dispose();
        self.costInfo:clear();
        self.costInfo = nil;
    end
    if self.dragList ~= nil then
        self.dragList:dispose();
        self.dragList = nil;
    end
    if self.redDotIcon ~= nil then
        self.redDotIcon:dispose();
        self.redDotIcon = nil;
    end
    if self.modelScenePanel ~= nil then
        self.modelScenePanel:dispose();
        self.modelScenePanel = nil;
    end
    self:superCall("dispose");
end














-- 消耗item
Lua_LifeTreeCostItem = class("Lua_LifeTreeCostItem", Lua_DisplayObject);
function Lua_LifeTreeCostItem:ctor(p)
    self:superCall("ctor", p,"LifeTreeCostItem_skin");
end

function Lua_LifeTreeCostItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_LifeTreeCostItem:setData(list)
	local tvo = Lua_ToolVo.new(list[1]);
	local need_num = list[2];
	local bagNum = DataCenter.packData:getItemCountById(list[1]);

    if bagNum < need_num then
        bagNum = "<color=#f58787>"..numberTrans(bagNum).."</color>";
    else
        bagNum = numberTrans(bagNum);
    end

    self.cost_value.text = bagNum.."/"..numberTrans(need_num);
    self.cost_icon:setAltas(tvo.atlas, tvo.sprite);
end

function Lua_LifeTreeCostItem:dispose()
    self.data = nil;
    self:superCall("dispose");
end

