-- 图腾材料消耗
Lua_TotemHeroSelectWindow = class("Lua_TotemHeroSelectWindow", Lua_Window);
function Lua_TotemHeroSelectWindow:ctor()
	self:superCall("ctor");
	self.windowName = "Lua_TotemHeroSelectWindow";
	self.skinName = "TotemHeroSelectWindow_skin";
end

function Lua_TotemHeroSelectWindow:buildShowItem()
	self:superCall("buildShowItem");
    self.show_obj:SetActive(false);
    self:addLuaEvent("TOTEM_SELECT_HERO_ITEM", self, self.updataSelectItemInfo); -- 选择单个英雄返回

	self.dragList = Lua_DragList.new(self.content,590, 380, Lua_AxisDefine.Vertical);
    self.dragList:setListCell(Lua_TotemHeroSelectCell, 106, 106, 5);
    self.dragList:setCellSpacing(15, 15);
    self.dragList:setLocation(0, 203);

    self.subBtn:addClickFuntion(self, self.onSubClick);
    self.select_btn:addClickFuntion(self, self.onAllSelectClick);
end

-- 英雄展示数据
function Lua_TotemHeroSelectWindow:showWin(param)
    local cost_hvo = param.cost_hvo;--消耗材料hvo
    self.need_num = cost_hvo.need_num;

    local list = param.dic;
    self.showSelectHeroDic = {};
    if list ~= nil then
        for k,v in pairs(list) do
            self.showSelectHeroDic[k] = v;
        end
    end
    self.showInfo = DataCenter.totemData:getTotemHeroInfo(cost_hvo,self.showSelectHeroDic);
    self.show_obj:SetActive(self.showInfo:getSize() == 0);
    self.dragList:setArrayData(self.showInfo);
    self:updateSelectCostNum();
end

function Lua_TotemHeroSelectWindow:updateSelectCostNum()
    local selectNum = self.selectNum;
    if selectNum < self.need_num then
        selectNum = "<color=#FF0000>"..selectNum.."</color>";
    else
        selectNum = "<color=#FFFFFF>"..selectNum.."</color>";
    end

    self.select_num.text = LanUtil.formateStr(126637, selectNum,tostring(self.need_num));
end

function Lua_TotemHeroSelectWindow:updataSelectItemInfo(data) -- 选择道具数据
    if self.selectNum >= self.need_num and self.showSelectHeroDic[data.uid] == nil then
        OperateAlert.showLangValue(126638);
        return;
    end

    if data.isSelect == false then
        data.isSelect = true;
        self.showSelectHeroDic[data.uid] = 1;
    else
        data.isSelect = false;
        self.showSelectHeroDic[data.uid] = nil;
    end
    
    self:updateSelect();
    self:updateSelectCostNum();
end

function Lua_TotemHeroSelectWindow:updateSelect()
    if self.dragList ~= nil then
        local arr = self.dragList.showList;
        local len = arr:getSize();
        for i = 1, len do
            arr[i]:updateSelect();
        end
    end
end

function Lua_TotemHeroSelectWindow:onAllSelectClick() -- 一键选择
    if self.selectNum >=self.need_num then
        OperateAlert.showLangValue(126638);
        return;
    end
    if self.dragList ~= nil then
        local arr = self.dragList.showList;
        local len = arr:getSize();
        for i = 1, len do
            if self.showSelectHeroDic[arr[i].data.uid] == nil and self.selectNum < self.need_num then
                arr[i].data.isSelect = true;
                self.showSelectHeroDic[arr[i].data.uid] = 1;
            end
            arr[i]:updateSelect();
        end
    end
    self:updateSelectCostNum();
end

function Lua_TotemHeroSelectWindow.Get:selectNum()
    local selectNum = 0;
    for k,v in pairs(self.showSelectHeroDic) do
        if v == 1 then
            selectNum = selectNum +1;
        end
    end
    return selectNum
end

function Lua_TotemHeroSelectWindow:onSubClick() -- 确定
    if self.showInfo:getSize() == 0 then
        OperateAlert.showLangValue(126639);
        return;
    end

    Lua_MsgUtil.callFunc("SURE_SELECT_HERO_INFO", self.showSelectHeroDic);
    self:hide();
end

function Lua_TotemHeroSelectWindow:onBtnCloseClick(go)
    Lua_MsgUtil.callFunc("RECORD_SELECT_HERO_INFO", self.showSelectHeroDic);
    self:hide();
end

function Lua_TotemHeroSelectWindow:onMaskClick(go)
    Lua_MsgUtil.callFunc("RECORD_SELECT_HERO_INFO", self.showSelectHeroDic);
    self:hide();
end

function Lua_TotemHeroSelectWindow:dispose()
    if self.dragList ~= nil then
        self.dragList:dispose();
        self.dragList = nil;
    end
    self.showInfo = nil;
    self.showSelectHeroDic = nil
    self:superCall("dispose");
end
















-- 英雄选择Item
Lua_TotemHeroSelectCell = class("Lua_TotemHeroSelectCell", Lua_ListCell);
function Lua_TotemHeroSelectCell:ctor(p)
    self:superCall("ctor", p);
end

function Lua_TotemHeroSelectCell:buildShowItem()
	self:superCall("buildShowItem");

    self.itemIcon = Lua_ItemIcon.new(self.content);
    self.itemIcon:setCanClick(false);
    self.itemIcon:setSiblingIndex(0)

    self.select_bg = UICreate.createUIAtlasImage(self.content, "iconantlas1", "common_progress_002_b", 0, 0, 106, 106);
    self.select_bg:setEnable(false);
    self.select_sub = UICreate.createUIAtlasImage(self.content, "iconantlas1", "common_widget_015", 0, 0, 0, 0);
    self.select_sub:setEnable(false);
    self.lock = UICreate.createUIAtlasImage(self.content, "iconantlas1", "common_icon_006", 0, 0, 0, 0);
    self.lock:setEnable(false);
end

function Lua_TotemHeroSelectCell:setData(data)
    self.data = data;
    if data.id ~= nil then
        self.vo = Lua_ToolVo.toolVo(data.id);
    else
        self.vo = DataCenter.heroData:getItemByUniqueId(data.uid);
    end

    self.itemIcon:setData(self.vo);

    if self.vo.isSpecialState == true then
        self.lock:setEnable(true);
    else
        self.lock:setEnable(false);
    end
	self:updateSelect()
end

function Lua_TotemHeroSelectCell:updateSelect()
    -- print("更新   =- =",self.data.unique_id)
    self.select_bg:setEnable(self.data.isSelect);
    self.select_sub:setEnable(self.data.isSelect);
end

function Lua_TotemHeroSelectCell:onPressClick(go)
	if self.vo.isSpecialState == true then
        OperateAlert.showLangValue(126206);
		return;
	end
    Lua_MsgUtil.callFunc("TOTEM_SELECT_HERO_ITEM",self.data);
end

function Lua_TotemHeroSelectCell:dispose()
    self.data = nil;
    if self.itemIcon ~= nil then
        self.itemIcon:dispose();
        self.itemIcon = nil;
    end
    self.lock = nil;
    self.select_bg = nil;
    self.select_sub = nil;
    self:superCall("dispose");
end