--注灵
checkRequire("Lua_TotemAttrItem");
checkRequire("Lua_TotemResourceCostItem");
Lua_TotemLevelPanel = class("Lua_TotemLevelPanel", Lua_DisplayObject);
function Lua_TotemLevelPanel:ctor(p)
    self:superCall("ctor", p,"TotemLevel_skin");
end

function Lua_TotemLevelPanel:buildShowItem()
    self:superCall("buildShowItem");
    self.upgradeBtn:addClickFuntion(self, self.onUpgradeBtnClick);
    self:addLuaEvent("UPDATE_UPGRADE_INFO", self, self.updateShowPanel);
end

--更新数据
function Lua_TotemLevelPanel:updateShowPanel(camp)
    self.data = DataCenter.totemData:getTotemVoByCamp(camp);

    if self.data.isMaxLevel == true then
        self.showBar:setText("Max");
        self.showBar:setMaxValue(1);
        self.showBar:setValue(1);
        self.upgradeBtn:setLangValue(126641);
        self:showCostInfo(nil);
    else
        self.showBar:setText(self.data.cur_progress.."/"..self.data.total_progress);
        self.showBar:setMaxValue(self.data.total_progress);
        self.showBar:setValue(self.data.cur_progress);
        self.upgradeBtn:setLangValue(126632);
        self:showCostInfo(self.data.level_up_cost);
    end
    self.upgradeBtn:setGray(self.data.isMaxLevel == true);

    self.level.text = LanUtil.formateStr(126640,tostring(self.data.level));
    self:showAttr(self.data.curPropInfo);
    
end

-- 属性
function Lua_TotemLevelPanel:showAttr(arr)
    if arr ~= nil and arr:getSize() > 0 then
        if self.attrInfo == nil then
            self.attrInfo = Array();
        end
        local len = self.attrInfo:getSize();
        for i = 1, len do
            self.attrInfo[i]:setEnable(false);
        end
        local item;
        for i=1,arr:getSize() do
            if self.attrInfo[i] ~= nil then
                item = self.attrInfo[i];
            else
                item = Lua_TotemAttrItem.new(self.content);
                self.attrInfo:add(item);
            end
            item:setData(arr[i]);
            item:setLocation(-210 + (i-1)*160, -220, 0)
            item:setEnable(true);
        end
    else
        if self.attrInfo ~= nil then
            for i=1,self.attrInfo:getSize() do
                self.attrInfo[i]:setEnable(false);
            end
        end
    end
end

-- 升级材料展示
function Lua_TotemLevelPanel:showCostInfo(list)
    if list ~= nil then
        if self.costInfo == nil then
            self.costInfo = Array();
        end
        local width = 200;
        local len = self.costInfo:getSize();
        for i = 1, len do
            self.costInfo[i]:setEnable(false);
        end
        for i = 1, #list do
            local item = nil;
            if self.costInfo[i] ~= nil then
                item = self.costInfo[i];
            else
                item = Lua_TotemResourceCostItem.new(self.content);
                self.costInfo:add(item);
            end
            item:setData(list[i]);
            item:setLocation(-1 * width * #list / 2 + width * (i-1) + width / 2 - 100, -470, 0);
            item:setEnable(true);
        end
    else
        self.cost_list = nil;
        if self.costInfo ~= nil then
            local len = self.costInfo:getSize();
            for i = 1, len do
                self.costInfo[i]:setEnable(false);
            end
        end
    end
end

--注灵
function Lua_TotemLevelPanel:onUpgradeBtnClick()
    if self.data.isMaxLevel == true then
        OperateAlert.show(LanUtil.formateStr(126642, tostring(self.data.name)));
        return
    end
    if self.data.isUpgrade == true then
        Lua_ProxyManager.getProxy("Lua_TotemProxy"):sTotemUpgrade(self.data.id);
    else
        DataCenter.packUtil:openPathWindow(self.data.isUpgrade);
    end
end

function Lua_TotemLevelPanel:dispose()
    if self.attrInfo ~= nil then
        self.attrInfo:dispose();
        self.attrInfo:clear();
        self.attrInfo = nil;
    end

    if self.costInfo ~= nil then
        self.costInfo:dispose();
        self.costInfo:clear();
        self.costInfo = nil;
    end
    self:superCall("dispose");
end