--升阶
checkRequire("Lua_TotemHeroCostItem");
checkRequire("Lua_TotemResourceCostItem");
Lua_TotemOrderPanel = class("Lua_TotemOrderPanel", Lua_DisplayObject);
function Lua_TotemOrderPanel:ctor(p)
    self:superCall("ctor", p,"TotemOrderPanel_skin");
end

function Lua_TotemOrderPanel:buildShowItem()
    self:superCall("buildShowItem");
    self.skill_icon_l:addClickFuntion(self, self.onSkillLClick);
    self.skill_icon_r:addClickFuntion(self, self.onSkillRClick);

    self.tipsBtn:addClickFuntion(self, self.onShowTipsBtnClick);
    self.tips:addClickFuntion(self, self.onShowTipsBtnClick);

    self.orderBtn:addClickFuntion(self, self.onOrderBtnClick);
    self:addLuaEvent("UPDATE_ORDER_INFO", self, self.updateShowPanel);
    self:addLuaEvent("SURE_SELECT_HERO_INFO", self, self.sureSelectHeroInfo);    -- 确定选择了材料
    self:addLuaEvent("RECORD_SELECT_HERO_INFO", self, self.recordSelectHeroInfo);-- 记录英雄返回
end

--更新数据
function Lua_TotemOrderPanel:updateShowPanel(camp)
    self.sureSelectHeroDic = nil;
    self.recordSelectHeroDic = nil;
    self.data = DataCenter.totemData:getTotemVoByCamp(camp);

    if self.data.isMaxOrder == true then
        self.skill_level_l.text = self.data.order;
        self.skill_icon_l:setGray(false);
        self.skill_icon_l:setAltas("totem_atlas",self.data.skill_sprite);
        self.skill_obj_r:SetActive(false);

        LuaUtil.setObjPos(self.skill_obj_l, 0, 0, 0);

        self.orderBtn:setLangValue(126645);
        self.condition:setLangValue(126646);
        self.condition:setEnable(true);
        self:showCostInfo(nil);
        self:showHeroCostInfo(nil);
    else
        if self.data.order == 0 then
            self.skill_level_l.text = 1;
            self.skill_icon_l:setGray(true);
            self.skill_icon_l:setAltas("totem_atlas",self.data.skill_sprite);
            self.skill_obj_r:SetActive(false);
            LuaUtil.setObjPos(self.skill_obj_l, 0, 0, 0);
        else
            self.skill_level_l.text = self.data.order;
            self.skill_icon_l:setGray(false);

            self.skill_level_r.text = self.data.order+1;
            self.skill_icon_r:setGray(true);

            self.skill_icon_l:setAltas("totem_atlas",self.data.skill_sprite);
            self.skill_icon_r:setAltas("totem_atlas",self.data.nextTotemOredrCofing.skill_sprite);

            self.skill_obj_r:SetActive(true);
            LuaUtil.setObjPos(self.skill_obj_l, -130, 0, 0);
        end
        self.orderBtn:setLangValue(126633);
        self.condition.text = LanUtil.formateStr(126644,tostring(self.data.level_cond));
        self.condition:setEnable(self.data.level < self.data.level_cond);
        self:showCostInfo(self.data.orderCostInfo);
        self:showHeroCostInfo(self.data.orderHeroVo);
    end
    self:showStarsItem(self.data.order);
    self.orderBtn:setGray(self.data.isMaxOrder == true); 
end

--确定选择了材料
function Lua_TotemOrderPanel:sureSelectHeroInfo(list)
    local selectNum = 0;
    for k,v in pairs(list) do
        if v == 1 then
            selectNum = selectNum +1;
        end
    end
    if selectNum == 0 then
        list = nil;
    end
    if self.totemHeroCostItem ~= nil then
        self.totemHeroCostItem:setSelectNum(selectNum);
    end
    self.sureSelectHeroDic = list;
    self.recordSelectHeroDic = list;-- 记录英雄返回
end

--记录英雄返回
function Lua_TotemOrderPanel:recordSelectHeroInfo(list)
    if self.sureSelectHeroDic ~= nil then
        self.recordSelectHeroDic = list;
    end
end

-- 消耗英雄
function Lua_TotemOrderPanel:showHeroCostInfo(data)
    if data ~= nil then
        if self.totemHeroCostItem == nil then
            self.totemHeroCostItem = Lua_TotemHeroCostItem.new(self.content);
            self.totemHeroCostItem:setLocation(-268, -470, 0)
        end
        self.totemHeroCostItem:setEnable(true);
        self.totemHeroCostItem:setData(data); 
    else
        if self.totemHeroCostItem ~= nil then
            self.totemHeroCostItem:setEnable(false);
        end
    end
end

--阶级
function Lua_TotemOrderPanel:showStarsItem(order)
    if order > 0 then
        if self.starInfo == nil then
            self.starInfo = Array();
        end
        local len = self.starInfo:getSize();
        local star = order;
        if order < 10 then
            star = order % 5;
            star = star == 0 and 5 or star;
        else
            star = 1;
        end
        local sn = DataCenter.heroUtil:getStarSprite(order, 2);
        local num = len;
        if len < star then
            num = star;
        end
        
        for i = 1, num do
            local item = self.starInfo[i];
            if item == nil then
                item = UICreate.createUIAtlasImage(self.content, "iconantlas1", "common_widget_024", 0, 0, 28, 28);
                self.starInfo:add(item);
                item.siblingIndex = 10 + i;
                item:setLocation(-255 + (i-1)*30, -219, 0);
                item:setAltas("iconantlas1", sn);
            else
                if i > star then
                    item:setEnable(false);
                else
                    item.siblingIndex = 10 + i;
                    item:setLocation(-255 + (i-1)*30, -219, 0);
                    item:setAltas("iconantlas1", sn);
                    item:setEnable(true);
                end
            end
        end
    else
        if self.starInfo ~= nil then
            local len = self.starInfo:getSize();
            for i = 1, len do
                self.starInfo[i]:setEnable(false);
            end
        end
    end
end

-- 升阶材料展示
function Lua_TotemOrderPanel:showCostInfo(list)
    if list ~= nil then
        if self.costInfo == nil then
            self.costInfo = Array();
        end
        local width = 200;
        local len = self.costInfo:getSize();
        for i = 1, len do
            self.costInfo[i]:setEnable(false);
        end
        for i = 1, #list do
            local item = nil;
            if self.costInfo[i] ~= nil then
                item = self.costInfo[i];
            else
                item = Lua_TotemResourceCostItem.new(self.content);
                self.costInfo:add(item);
            end
            item:setData(list[i]);
            item:setLocation(-1 * width * #list / 2 + width * (i-1) + width / 2, -470, 0);
            item:setEnable(true);
        end
    else
        self.cost_list = nil;
        if self.costInfo ~= nil then
            local len = self.costInfo:getSize();
            for i = 1, len do
                self.costInfo[i]:setEnable(false);
            end
        end
    end
end

--进阶
function Lua_TotemOrderPanel:onOrderBtnClick()
    if self.data.isLevelCond == false then
        OperateAlert.showLangValue(126652);
        return
    end

    if self.data.isMaxOrder == true then
        OperateAlert.show(LanUtil.formateStr(126653,tostring(self.data.name)));
        return
    end

    local selectNum = 0;
    if self.sureSelectHeroDic ~= nil then
        for k,v in pairs(self.sureSelectHeroDic) do
            if k > 0 then
                selectNum = selectNum +1;
            end
        end
    end
    if selectNum < self.data.orderHeroVo.need_num then
        OperateAlert.showLangValue(126636);
        return
    end

    if self.data.isCostOredr == true then
        Lua_ProxyManager.getProxy("Lua_TotemProxy"):sTotemOrder(self.data.id, self.sureSelectHeroDic);
    else
        DataCenter.packUtil:openPathWindow(self.data.isCostOredr);
    end
end

--左侧技能
function Lua_TotemOrderPanel:onSkillLClick()
    local isNext = false;
    if self.data.order == 0 then
        isNext = true;
    end
    Lua_WindowUtil.openWin("Lua_TotemSkillTipsWindow", Lua_WinParam.ACTION_OPEN,{id = self.data.id,isNext = isNext});
end

--右侧技能
function Lua_TotemOrderPanel:onSkillRClick()
    Lua_WindowUtil.openWin("Lua_TotemSkillTipsWindow", Lua_WinParam.ACTION_OPEN,{id = self.data.id,isNext = true});
end

--详情
function Lua_TotemOrderPanel:onShowTipsBtnClick()
    Lua_WindowUtil.openWin("Lua_TotemOrderTipsWindow", Lua_WinParam.ACTION_OPEN, self.data);
end

function Lua_TotemOrderPanel:dispose()
    if self.costInfo ~= nil then
        self.costInfo:dispose();
        self.costInfo:clear();
        self.costInfo = nil;
    end

    if self.starInfo ~= nil then
        self.starInfo:dispose();
        self.starInfo:clear();
        self.starInfo = nil;
    end

    if self.totemHeroCostItem ~= nil then
        self.totemHeroCostItem:dispose();
        self.totemHeroCostItem = nil;
    end
    self:superCall("dispose");
end














-- 消耗item
Lua_TotemLevelCostItem = class("Lua_TotemLevelCostItem", Lua_DisplayObject);
function Lua_TotemLevelCostItem:ctor(p)
    self:superCall("ctor", p,"LifeTreeCostItem_skin");
end

function Lua_TotemLevelCostItem:buildShowItem()
    self:superCall("buildShowItem");
end

function Lua_TotemLevelCostItem:setData(list)
    local tvo = Lua_ToolVo.new(list[1]);
    local need_num = list[2];
    local bagNum = DataCenter.packData:getItemCountById(list[1]);

    if bagNum < need_num then
        bagNum = "<color=#FF0000>"..numberTrans(bagNum).."</color>";
    else
        bagNum = numberTrans(bagNum);
    end
    local str = bagNum.."/"..numberTrans(need_num);
    self.cost_value.text = "<color=#4a6793>"..str.."</color>";
    self.cost_icon:setAltas(tvo.atlas, tvo.sprite);
end

function Lua_TotemLevelCostItem:dispose()
    self.data = nil;
    self:superCall("dispose");
end

