-- 图腾升阶详情
Lua_TotemOrderTipsWindow = class("Lua_TotemOrderTipsWindow", Lua_Window);
function Lua_TotemOrderTipsWindow:ctor()
	self:superCall("ctor");
	self.windowName = "Lua_TotemOrderTipsWindow";
	self.skinName = "TotemOrderTipsWindow_skin";
end

function Lua_TotemOrderTipsWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.dragList = Lua_DragList.new(self.content,614, 768, Lua_AxisDefine.Vertical);
    self.dragList:setListCell(Lua_TotemOrderTipsCell, 614, 170, 1);
    self.dragList:setCellSpacing(0, 10);
    self.dragList:setLocation(0, 340);
end

function Lua_TotemOrderTipsWindow:showWin(param)

    local arr = DataCenter.totemUtil:getOrderInfoByCamp(param.id, param.order);
    self.dragList:setArrayData(arr);
    self.dragList:moveToIndex(param.order,true);
end

function Lua_TotemOrderTipsWindow:dispose()
    if self.dragList ~= nil then
        self.dragList:dispose();
        self.dragList = nil;
    end

    self:superCall("dispose");
end




















Lua_TotemOrderTipsCell = class("Lua_TotemOrderTipsCell", Lua_ListCell);
function Lua_TotemOrderTipsCell:ctor(p)
    self:superCall("ctor", p,"TotemOrderTipsCell_skin");
end

function Lua_TotemOrderTipsCell:buildShowItem()
    self:superCall("buildShowItem");
end

function Lua_TotemOrderTipsCell:setData(data)
    self.name.text = data.data.name;
    self.show_obj:SetActive(data.isSelect);
    self.select_bg:setEnable(data.isSelect);
    self:showAttr(data.data.orderPropInfo);

end

-- 属性
function Lua_TotemOrderTipsCell:showAttr(arr)
    if arr ~= nil and arr:getSize() > 0 then
        if self.attrInfo == nil then
            self.attrInfo = Array();
        end
        local pos = {{-265,0},{-59,0},{-265,-40}}
        local len = self.attrInfo:getSize();
        for i = 1, len do
            self.attrInfo[i]:setEnable(false);
        end
        local item;
        for i=1,arr:getSize() do
            if self.attrInfo[i] ~= nil then
                item = self.attrInfo[i];
            else
                item = Lua_TotemAttrItem.new(self.content);
                self.attrInfo:add(item);
            end
            item:setData(arr[i]);
            item:setLocation(pos[i][1], pos[i][2], 0)
            item:setEnable(true);
        end
    else
        if self.attrInfo ~= nil then
            for i=1,self.attrInfo:getSize() do
                self.attrInfo[i]:setEnable(false);
            end
        end
    end
end

function Lua_TotemOrderTipsCell:dispose()
    if self.attrInfo ~= nil then
        self.attrInfo:dispose();
        self.attrInfo:clear();
        self.attrInfo = nil;
    end
    self:superCall("dispose");
end