--图腾
checkRequire("Lua_TotemSiftItem");
checkRequire("Lua_TotemAttrItem");
checkRequire("Lua_TotemLevelPanel");--注灵
checkRequire("Lua_TotemOrderPanel");--升阶
checkRequire("Lua_TotemHeroCostItem");
Lua_TotemPanel = class("Lua_TotemPanel", Lua_DisplayObject);
function Lua_TotemPanel:ctor(p)
    self:superCall("ctor", p,"TotemPanel_skin");
end

function Lua_TotemPanel:buildShowItem()
    self:superCall("buildShowItem");
    self.selectType = 0;
    self.panelObjTab = {};
    self.sureSelectHeroDic = nil;  -- 确定选择了材料
    self.recordSelectHeroDic = nil;-- 记录英雄返回

    self.unlock_obj:SetActive(false);
    self:addLuaEvent("SELECT_TOTEM_TYPE", self, self.updateTotemSiftInfo);

    local siftAllInfo = DataCenter.heroUtil.siftInfo;
    self.siftInfo = Array();
    local len = siftAllInfo:getSize();
    local perWidth = 75;
    for i=1,len do
        local siftItem = Lua_TotemSiftItem.new(self.content);
        siftItem:setData(siftAllInfo[i]);
        siftItem:setLocation(-1 * perWidth * len / 2 + perWidth * (i-1) + perWidth / 2, 500, 0);
        self.siftInfo:add(siftItem);
    end

    self.help:addClickFuntion(self, self.onHelpBtnClick);
    self.addBtn:addClickFuntion(self, self.onAddBtnClick);--加
    self.subBtn:addClickFuntion(self, self.onSubBtnClick);--减
    self.unlockBtn:addClickFuntion(self, self.onUnlockBtnClick);

    self:addLuaEvent("UPDATE_TOTEM_INFO", self, self.updateTotemSiftInfo);--请求界面信息返回

    self:addLuaEvent("UPDATE_ORDER_INFO", self, self.updateTotemInfo);   -- 升阶
    self:addLuaEvent("UPDATE_UPGRADE_INFO", self, self.updateTotemInfo); -- 注灵
    self:addLuaEvent("UPDATE_ACTIVATE_INFO", self, self.updateTotemInfo);-- 解锁

    self:addLuaEvent("ON_HERO_SELECT_WINDOW", self, self.onHeroSelectWindwo);--点击英雄消耗材料
    self:addLuaEvent("SURE_SELECT_HERO_INFO", self, self.sureSelectHeroInfo);    -- 确定选择了材料
    self:addLuaEvent("RECORD_SELECT_HERO_INFO", self, self.recordSelectHeroInfo);-- 记录英雄返回
    if DataCenter.totemData.bInitTotemInfo == false then
        Lua_ProxyManager.getProxy("Lua_TotemProxy"):sTotem();
    else
        self:updateTotemSiftInfo(1);
    end
end

function Lua_TotemPanel:updateTotemSiftInfo(selectType) -- 更新筛选状态
    if selectType == nil then
        selectType = 1;
    end
    if self.selectType == selectType then
        return;
    end
    self.tabIndex = 1;
    self.selectType = selectType;

    local len = self.siftInfo:getSize();
    for i=1, len do
        local _type = self.siftInfo[i].data;
        if _type == selectType then
            self.siftInfo[i]:setSelectEnable(true);
        else
            self.siftInfo[i]:setSelectEnable(false);
        end
    end
    self:updateTotemInfo(selectType)
end

--更新选的的图腾
function Lua_TotemPanel:updateTotemInfo(camp)
    self.sureSelectHeroDic = nil;
    self.recordSelectHeroDic = nil;
    self.data = DataCenter.totemData:getTotemVoByCamp(camp);
    if self.data.is_activate == 1 then--已激活
        self.unlock_obj:SetActive(false);
        self:initBtnList(true);
        self:showUnlockAttr(nil);
        self:showHeroCostInfo(nil);
    else
        self:initBtnList(false);
        self.unlock_obj:SetActive(true);
        self:showUnlockAttr(self.data.lock_prop);
        self:showHeroCostInfo(self.data.unlockHeroVo);
    end
    self.showImage:setUrl("/images/hero/"..self.data.images..".png");
    self.campSpr:setAltas("totem_atlas",self.data.camp_spr);
    self:updateshowInfo();
end

function Lua_TotemPanel:updateshowInfo()
    if self.data.is_activate == 1 then--已激活
        if self.data.order == 0 then
            self.name.text = LanUtil.formateStr(126634,tostring(self.data.name),tostring(self.data.level));
        else
            self.name.text = LanUtil.formateStr(126635,tostring(self.data.name),tostring(self.data.order),tostring(self.data.level));
        end
    else
        self.name.text = self.data.name;
    end
    self:showAllAttr(self.data.allPropInfo);
end

--打开英雄选择界面
function Lua_TotemPanel:onHeroSelectWindwo(cost_hvo)
    Lua_WindowUtil.openWin("Lua_TotemHeroSelectWindow", Lua_WinParam.ACTION_OPEN, {cost_hvo = cost_hvo, dic = self.recordSelectHeroDic});
end

--确定选择了材料
function Lua_TotemPanel:sureSelectHeroInfo(list)
    local selectNum = 0;
    for k,v in pairs(list) do
        if v == 1 then
            selectNum = selectNum +1;
        end
    end
    if selectNum == 0 then
        list = nil;
    end
    if self.totemHeroCostItem ~= nil then
        self.totemHeroCostItem:setSelectNum(selectNum);
    end
    self.sureSelectHeroDic = list;
    self.recordSelectHeroDic = list;-- 记录英雄返回
end

--记录英雄返回
function Lua_TotemPanel:recordSelectHeroInfo(list)
    if self.sureSelectHeroDic == nil then
        self.recordSelectHeroDic = list;
    end
end

function Lua_TotemPanel:initBtnList(bool)
    if bool then
        if self.tabInfo == nil then
            self.tabInfo = Array();
            self.tabInfo:add({textAtlas = "hero_title", textNormalSprite = "fonts_003", tagType = 1,  panel = Lua_TotemLevelPanel});
            self.tabInfo:add({textAtlas = "hero_title", textNormalSprite = "fonts_004", tagType = 2, panel = Lua_TotemOrderPanel});

            self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
            self.btnList:setLocation(0, -140, 0);
            self.btnList:setButtonItem(184, 62);
            self.btnList:setClickCallBack(self, self.onTabBtnClick);
            self.btnList:setData(self.tabInfo);
        end
        self.btnList:setEnable(true);
        self.btnList:setSelected(self.tabIndex);
        if self.selectTabIndex == self.tabIndex then
            local panel = self.panelObjTab[self.tabIndex];
            if panel ~= nil then
                panel:setEnable(true);
                panel:updateShowPanel(self.selectType);
            end
        end
    else
        if self.btnList ~= nil then
            self.btnList:setEnable(false);
            for idx, panelObj in pairs(self.panelObjTab) do
                panelObj:setEnable(false);
            end
        end
    end
end

--页签
function Lua_TotemPanel:onTabBtnClick(val)
    if self.selectTabIndex == val then
        return;
    end
    -- 隐藏旧的
    local panel = self.panelObjTab[self.selectTabIndex];
    if panel ~= nil then
        panel:setEnable(false);
    end
    self.tabIndex = val;
    self.selectTabIndex = val;
    panel = self.panelObjTab[val];
    if self.panelObjTab[val] == nil then
        local showPanel = self.tabInfo[val].panel;
        panel = showPanel.new(self.content);
        self.panelObjTab[val] = panel;
    else
        panel:setEnable(true);
    end
    panel:updateShowPanel(self.selectType);
    self:updateshowInfo();
end

-- 总属性
function Lua_TotemPanel:showAllAttr(arr)
    if arr ~= nil and arr:getSize() > 0 then
        if self.allAttrInfo == nil then
            self.allAttrInfo = Array();
        end
        local len = self.allAttrInfo:getSize();
        for i = 1, len do
            self.allAttrInfo[i]:setEnable(false);
        end
        local item;
        local perWidth = 200;
        for i=1,arr:getSize() do
            if self.allAttrInfo[i] ~= nil then
                item = self.allAttrInfo[i];
            else
                item = Lua_TotemAttrItem.new(self.content);
                self.allAttrInfo:add(item);
            end
            item:setData(arr[i]);
            item:setLocation(-1 * perWidth * arr:getSize() / 2 + perWidth * (i-1) + perWidth / 2-30, -46, 0)
            item:setEnable(true);
        end
    else
        if self.allAttrInfo ~= nil then
            for i=1,self.allAttrInfo:getSize() do
                self.allAttrInfo[i]:setEnable(false);
            end
        end
    end
end

-- 解锁属性
function Lua_TotemPanel:showUnlockAttr(arr)
    if arr ~= nil and arr:getSize() > 0 then
        if self.unlockAttrInfo == nil then
            self.unlockAttrInfo = Array();
        end
        local len = self.unlockAttrInfo:getSize();
        for i = 1, len do
            self.unlockAttrInfo[i]:setEnable(false);
        end
        local item;
        local perWidth = 200;
        for i=1,arr:getSize() do
            if self.unlockAttrInfo[i] ~= nil then
                item = self.unlockAttrInfo[i];
            else
                item = Lua_TotemAttrItem.new(self.unlock_obj);
                self.unlockAttrInfo:add(item);
            end
            item:setData(arr[i]);
            item:setLocation(-1 * perWidth * arr:getSize() / 2 + perWidth * (i-1) + perWidth / 2-30, -335, 0)
            item:setEnable(true);
        end
    else
        if self.unlockAttrInfo ~= nil then
            for i=1,self.unlockAttrInfo:getSize() do
                self.unlockAttrInfo[i]:setEnable(false);
            end
        end
    end
end

-- 解锁消耗英雄
function Lua_TotemPanel:showHeroCostInfo(data)
    if data ~= nil then
        if self.totemHeroCostItem == nil then
            self.totemHeroCostItem = Lua_TotemHeroCostItem.new(self.unlock_obj);
            self.totemHeroCostItem:setLocation(-100, -465, 0)
        end
        self.totemHeroCostItem:setEnable(true);
        self.totemHeroCostItem:setData(data); 
    else
        if self.totemHeroCostItem ~= nil then
            self.totemHeroCostItem:setEnable(false);
        end
    end
end

--加
function Lua_TotemPanel:onAddBtnClick()
    local selectType = self.selectType + 1;
    if selectType > Lua_HeroUtil.DARK_TYPE then
       selectType = 1;
    end
    self:updateTotemSiftInfo(selectType);
end

--减
function Lua_TotemPanel:onSubBtnClick()
    local selectType = self.selectType - 1;
    if selectType < 1 then
        selectType = Lua_HeroUtil.DARK_TYPE;
    end
    self:updateTotemSiftInfo(selectType);
end

--解锁
function Lua_TotemPanel:onUnlockBtnClick()
    local selectNum = 0;
    if self.sureSelectHeroDic ~= nil then
        for k,v in pairs(self.sureSelectHeroDic) do
            if k > 0 then
                selectNum = selectNum +1;
            end
        end
    end
    if selectNum < self.data.unlockHeroVo.need_num then
        OperateAlert.showLangValue(126636);
        return
    end
    Lua_ProxyManager.getProxy("Lua_TotemProxy"):sHalidoActivate(self.selectType, self.sureSelectHeroDic);
end

function Lua_TotemPanel:onHelpBtnClick()
    local tipsData = { des = LanUtil.getValue(126631), posX = 80, posY = 462 };
    Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_TotemPanel:dispose()
    if self.panelObjTab ~= nil then
        for idx, panelObj in pairs(self.panelObjTab) do
            panelObj:dispose();
            self.panelObjTab[idx] = nil;
        end
        self.panelObjTab = nil;
    end

    if self.tabInfo ~= nil then
        self.tabInfo:dispose();
        self.tabInfo:clear();
        self.tabInfo = nil;
    end

    if self.siftInfo ~= nil then
        self.siftInfo:dispose();
        self.siftInfo:clear();
        self.siftInfo = nil;
    end

    if self.allAttrInfo ~= nil then
        self.allAttrInfo:dispose();
        self.allAttrInfo:clear();
        self.allAttrInfo = nil;
    end

    if self.unlockAttrInfo ~= nil then
        self.unlockAttrInfo:dispose();
        self.unlockAttrInfo:clear();
        self.unlockAttrInfo = nil;
    end

    if self.totemHeroCostItem ~= nil then
        self.totemHeroCostItem:dispose();
        self.totemHeroCostItem = nil;
    end
    self.data = nil;
    self.sureSelectHeroDic = nil;  -- 确定选择了材料
    self.recordSelectHeroDic = nil;-- 记录英雄返回
    self:superCall("dispose");
end
